//
//  GDSTaskControllerTests.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.06.
//  Copyright 2005 Green Dome Software. All rights reserved.
//

#import "GDSTaskControllerTests.h"

#import "GDSTaskController.h"

@implementation GDSTaskControllerTests

- (void)test1
{
    GDSTaskActionMonitor* monitor = [GDSTaskActionMonitor monitor];

    UKIntsEqual([monitor outcome], GDSTaskActionInProgress);
    UKTrue([[monitor results] isKindOfClass:[NSMutableDictionary class]]);
    UKTrue([[[monitor results] valueForKey:GDSTaskActionResultRawOutputKey] isKindOfClass: [NSString class]]);

    NSLog(@"results = %@", [monitor results]);
}

- (void)test2
{
    GDSTaskController* tc = [[GDSTaskController alloc] initWithLaunchPath: @"/bin/ls"
                                                                arguments: [NSArray arrayWithObjects: @"-ltr", @"/", nil]];
    NSLog(@"Controller created.");

    GDSTaskActionMonitor* monitor = [[tc launch] retain];

    NSLog(@"Task launched.");

    UKIntsEqual([monitor outcome], GDSTaskActionInProgress);

    [[NSRunLoop currentRunLoop] runUntilDate: [NSDate dateWithTimeIntervalSinceNow: 1.0]];

    UKIntsEqual([monitor outcome], GDSTaskActionSuccess);
    
    NSLog(@"ls output:\n%@\n", [[monitor results] valueForKey: GDSTaskActionResultRawOutputKey]);

    [monitor release];
}

@end
