//
//  GDSThreadMessageQueue.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.03.22.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "GDSThreadMessageQueue.h"


enum
{
    kQueueEmpty,
    kQueueNotEmpty
};

@implementation GDSThreadMessageQueue

- (id)init
{
    if ( self = [super init] )
    {
        mQueue = [[NSMutableArray alloc] init];
        mConditionLock = [[NSConditionLock alloc] initWithCondition: kQueueEmpty];
    }
    
    return super;
}

- (void)dealloc
{
    [mCoditionLock release];
    [mQueue release];

    [super dealloc];
}

- (void)addMessage: (id)aMessage
{
    [mConditionLock lock];

    [mQueue insertObject: aMessage atIndex: 0];

    [mConditionLock unlockWithCondition: kQueueNotEmpty];
}

- (id)nextMessage
{
    [mConditionLock lockWhenCondition: kQueueNotEmpty];

    id  aMessage = [mQueue lastObject];
    
    [mQueue removeLastObject];

    [mConditionLock unlockWithCondition: [mQueue count] == 0 ? kQueueEmpty : kQueueNotEmpty];
}

@end
