//
//  NSArray(Extensions).m
//  Fugu
//
//  Created by Tim McIntosh on 2005.03.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "NSArray(Extensions).h"


@implementation NSArray (Extensions)

- (NSArray*) subarrayWithIndicesFromEnumerator: (NSEnumerator*)indexEnumerator
{
    NSMutableArray*     results = [NSMutableArray array];
    NSNumber*           index;

    NSAutoreleasePool*  pool = [[ NSAutoreleasePool alloc ] init ];
    
    while ((index = [indexEnumerator nextObject]) != nil)
    {
        NSAssert([index isKindOfClass: [NSNumber class]], @"Index is not a NSNumber");

        [results addObject: [self objectAtIndex: [index intValue]]];
    }

    [pool release];

    return [NSArray arrayWithArray: results];
}

- (BOOL) isNotEmpty
{
    return [self count] != 0;
}

@end
