/*
 * Copyright (c) 2003 Regents of The University of Michigan.
 * All Rights Reserved.  See COPYRIGHT.
 */

#import "NSMutableArray(Extensions).h"
#import "NSString(SSHAdditions).h"

@implementation NSMutableArray(Extensions)

// XXX - get rid of this kludge - TKM
- ( NSMutableArray * )visibleItems
{
    if ( self == nil || [ self count ] == 0 ) {
        return( nil );
    }
    
    NSMutableArray* vis = [ NSMutableArray array ];

    NSEnumerator* e = [ self objectEnumerator ];
    NSDictionary* file;

    while ( ( file = [ e nextObject ] ) != nil )
    {
        NSString* path = [ file  objectForKey: @"name" ];

        if ( [ path pathIsVisible ] )
        {
            [ vis addObject: file ];
        }
    }

    return vis;
}

- ( void )reverse
{
    NSMutableArray		*rev = nil;
    int				i;
    
    if ( self == nil || [ self count ] == 0 ) {
        return;
    }
    
    rev = [[ NSMutableArray alloc ] init ];
    
    for ( i = 0; i < [ self count ]; i++ ) {
        [ rev insertObject: [ self objectAtIndex: i ] atIndex: 0 ];
    }

    [ self setArray: rev ];
    [ rev release ];
}

@end
