/*
 * Copyright (c) 2003 Regents of The University of Michigan.
 * All Rights Reserved.  See COPYRIGHT.
 */
 
#import <Foundation/Foundation.h>

@interface NSString(SSHAdditions)

+ ( NSDictionary * )unknownHostInfoFromString: ( NSString * )string;

#if 0
// base = remote destination dir; last component is same as local dir
+ ( NSString * )pathFromBaseDir: ( NSString * )base fullPath: ( NSString * )fullpath;
#endif

+ ( NSString * )clockStringFromInteger: ( int )integer;
- ( NSString * )octalRepresentation;
- ( char )objectTypeFromOctalRepresentation: ( NSString * )octalRep;
- ( NSString * )stringRepresentationOfOctalMode;
- ( BOOL )containsString: ( NSString * )substring caseInsensitiveComparison: ( BOOL )cmp;
- ( BOOL )containsString: ( NSString * )substring;
- ( BOOL )beginsWithString: ( NSString * )substring;
#ifndef GNUSTEP
- ( Str255 * )pascalString;
#endif
- ( NSString * )stringByExpandingTildeInRemotePathWithHomeSetAs: ( NSString * )remoteHome;
- ( NSString * )descriptiveSizeString;
- ( NSString * )escapedPathString;

- ( BOOL )pathIsVisible;

@end
