/*
 * Copyright (c) 2003 Regents of The University of Michigan.
 * All Rights Reserved.  See COPYRIGHT.
 */

#include <AppKit/AppKit.h>

@class SFTPPrefs;
@class SCPController;

@interface SFTPAppController : NSObject
{
    SFTPPrefs			*prefs;

    SCPController		*scp;  // XXX - should allow multiple - tkm

#ifndef GNUSTEP
    /* rendezvous */
    NSNetServiceBrowser		*sshServiceBrowser;
    NSMutableDictionary         *services;   // NSString(hostName) -> NSDictionary(name,port)
#endif
}

#ifndef GNUSTEP
- ( NSArray * )rendezvousServers;
- ( void )scanForSSHServers;
#endif

- ( SCPController * )scp;

- ( IBAction )checkForUpdates: ( id )sender;

- ( IBAction )newDocument:(id)sender;

- ( IBAction )visitHomePage: ( id )sender;
- ( IBAction )emailAuthor: ( id )sender;
- ( IBAction )showPrefs: ( id )sender;
- ( IBAction )showItemFromHelpMenu: ( id )sender;

- ( IBAction )newSSHTunnel: ( id )sender;
- ( IBAction )secureCopy: ( id )sender;

@end
