//
//  SFTPCdCommand.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.09.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "SFTPCdCommand.h"
#import "SFTPClientTaskController.h"
#import "NSString+SFTPAdditions.h"


@implementation SFTPCdCommand

- (SFTPCdCommand*)initWithRemotePath:(NSString*)path
{
    self = [super init];
    if (self != nil)
    {
        mRemotePath = [path copy];
    }
    return self;
}

- (void) dealloc
{
    [mRemotePath release];
    [super dealloc];
}

- (NSString*)command
{
    return [NSString stringWithFormat: @"cd \"%@\"",
        [[self controller] absolutePathFromString: mRemotePath]];
}

- (NSString*)displayName
{
    return [NSString stringWithFormat: NSLocalizedString(@"switch to folder %@", @"cd command"), mRemotePath];
}

- (void)parseResponse:(NSArray*)response
{
    if ([response count] > 0)
    {
        NSString* status = [response lastObject];
    
        NSAssert([status containsSftpError], @"Expected error string in 'cd' response but found none.");

        [[self controller] setError: status];
    }
    else
    {
//        NSLog(@"Changed directory to %@", mRemotePath);
        
        [[self controller] setNeedsRefresh: YES];
    }

    [super parseResponse: response];
}

@end
