//
//  SFTPCommand.h
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.08.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class SFTPClientTaskController;

@interface SFTPCommand : NSObject
{
@private
    SFTPClientTaskController*   mController;
    BOOL                        mIsComplete;
    NSString*                   mError;
}

// TBD - (NSString*)longDescription;

- (NSString*)command;
- (NSString*)displayName;

- (void)parseResponse:(NSArray*)response;

- (BOOL)inProgress;
- (double)progress;
- (void)updateProgress:(NSMutableString*)response;
- (BOOL)isIndeterminate;
- (BOOL)isComplete;

- (BOOL)hasError;
- (NSString*)error;

@end

@interface SFTPCommand(PackageMethods)
- (SFTPClientTaskController*)controller;
- (void)setController:(SFTPClientTaskController*)controller;
- (void)setIsComplete:(BOOL)isComplete;
@end
