//
//  SFTPCommand.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.08.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "SFTPCommand.h"
#import "SFTPClientTaskController.h"


@implementation SFTPCommand

- (NSString*)description
{
    return [NSString stringWithFormat: @"<%@: %@>", NSStringFromClass([self class]), [self command]];
}

- (SFTPClientTaskController*)controller
{
    return mController;
}

- (void)setController:(SFTPClientTaskController*)controller
{
    mController = controller;
}

- (NSString*)command
{
    // Subclass responsibility.
    [self doesNotRecognizeSelector: _cmd];
    return nil;
}

- (NSString*)displayName
{
    return [NSString stringWithFormat: NSLocalizedString(@"perform command: %@", @"generic command"), [self command]];
}

- (void)parseResponse:(NSArray*)response
{
    [self setIsComplete: YES];
}

- (BOOL)inProgress
{
    return [[self controller] currentCommand] == self;
}

- (double)progress
{
    return [self inProgress] ? -1 : [self isComplete] ? 100 : 0;
}

- (void)updateProgress:(NSMutableString*)response
{
    // Does nothing by default.  Overridden by subclass.
}

- (BOOL)isIndeterminate
{
    return YES;
}

- (BOOL)isComplete
{
    return mIsComplete;
}

- (void)setIsComplete:(BOOL)isComplete
{
    mIsComplete = isComplete;
}

// These are convenience methods - TBD really needed?

- (BOOL)hasError
{
    // XXX need key/value dependencies for this
    return [self error] != nil;
}

- (NSString*)error
{
    return ([self inProgress] && [[self controller] error] != nil ? [[self controller] error] : nil);
}

@end
