//
//  SFTPFileTransferCommand.h
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.08.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "SFTPCommand.h"


typedef enum
{
    SFTPFileTransferDirectionDownload,
    SFTPFileTransferDirectionUpload
}
SFTPFileTransferDirection;


@interface SFTPFileTransferCommand : SFTPCommand
{
@private
    SFTPFileTransferDirection    mDirection;
    NSString*                    mLocalPath;
    NSString*                    mRemotePath;

    // Progress tracking:
    double                     mProgress;
    NSString*                   mEta;
    NSString*                   mBytesTransferred;
    NSString*                   mTransferRate;
}

- (SFTPFileTransferCommand*)initWithLocalPath:(NSString*)localPath
                                   remotePath:(NSString*)remotePath
                            transferDirection:(SFTPFileTransferDirection)direction;

- (NSString*)path;
- (NSString*)file;

- (NSString*)eta;
- (NSString*)bytesTransferred;
- (NSString*)transferRate;

- (BOOL)isUpload;

@end
