//
//  SFTPMkdirCommand.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.11.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

// XXX virtually identical to cd command - could merge these?

#import "SFTPMkdirCommand.h"
#import "SFTPClientTaskController.h"
#import "NSString+SFTPAdditions.h"

@implementation SFTPMkdirCommand

- (SFTPMkdirCommand*)initWithRemotePath:(NSString*)path
{
    self = [super init];
    if (self != nil)
    {
        mRemotePath  = [path copy];
    }
    return self;
}

- (void) dealloc
{
    [mRemotePath release];
    [super dealloc];
}

- (NSString*)command
{
    return [NSString stringWithFormat: @"mkdir \"%@\"",
        [[self controller] absolutePathFromString: mRemotePath]];
}

- (NSString*)displayName
{
    return [NSString stringWithFormat: NSLocalizedString(@"create new folder %@", @"mkdir command"), mRemotePath];
}

- (void)parseResponse:(NSArray*)response
{
    if ([response count] > 0)
    {
        NSString* status = [response lastObject];
        
        NSAssert([status containsSftpError], @"Expected error string in 'mkdir' response but found none.");
        
        [[self controller] setError: status];
    }
    else
    {
//        NSLog(@"Created directory %@", mRemotePath);
        
        [[self controller] setNeedsRefresh: YES];
    }
    
    [super parseResponse: response];
}

@end
