//
//  SFTPRenameCommand.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.09.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "SFTPRenameCommand.h"
#import "SFTPClientTaskController.h"
#import "NSString+SFTPAdditions.h"


@implementation SFTPRenameCommand

- (SFTPRenameCommand*)initWithOrigPath:(NSString*)origPath
                               newPath:(NSString*)newPath
{
    self = [super init];
    if (self != nil)
    {
        mOrigPath = [origPath copy];
        mNewPath  = [newPath copy];
    }
    return self;
}

- (void) dealloc
{
    [mOrigPath release];
    [mNewPath release];
    [super dealloc];
}

- (NSString*)command
{
    return [NSString stringWithFormat: @"rename \"%@\" \"%@\"",
        [[self controller] absolutePathFromString: mOrigPath],
        [[self controller] absolutePathFromString: mNewPath]];
}

- (NSString*)displayName
{
    return [NSString stringWithFormat: NSLocalizedString(@"rename %@ to %@", @"rename command"), mOrigPath, mNewPath];
}

- (void)parseResponse:(NSArray*)response
{
    if ([response count] > 0)
    {
        NSString* status = [response lastObject];

        NSAssert([status containsSftpError], @"Expected error string in 'rename' response but found none.");

        [[self controller] setError: status];
    }
    else
    {
//        NSLog(@"Renamed %@ to %@", mOrigPath, mNewPath);

        [[self controller] setNeedsRefresh: YES];
    }
    
    [super parseResponse: response];
}

@end
