//
//  SFTPRmCommand.m
//  Fugu
//
//  Created by Tim McIntosh on 2005.10.09.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "SFTPRmCommand.h"
#import "SFTPClientTaskController.h"
#import "NSString+SFTPAdditions.h"


@implementation SFTPRmCommand

- (SFTPRmCommand*)initWithRemotePath:(NSString*)path isDirectory:(BOOL)isDirectory
{
    self = [super init];
    if (self != nil)
    {
        mRemotePath  = [path copy];
        mIsDirectory = isDirectory;
    }
    return self;
}

- (void) dealloc
{
    [mRemotePath release];
    [super dealloc];
}

- (NSString*)command
{
    return [NSString stringWithFormat: @"%@ \"%@\"", mIsDirectory ? @"rmdir" : @"rm",
        [[self controller] absolutePathFromString: mRemotePath]];
}

- (NSString*)displayName
{
    return [NSString stringWithFormat: NSLocalizedString(@"delete %@", @"rm command"), mRemotePath];
}

- (void)parseResponse:(NSArray*)response
{
    if ([response count] > 0 && [[response lastObject] containsSftpError])
    {
        [[self controller] setError: [response lastObject]];
    }
    else
    {
        NSAssert(mIsDirectory || [[response lastObject] hasPrefix: @"Removing "], @"unexpected prefix");

        [[self controller] setNeedsRefresh: YES];
    }

    [super parseResponse: response];
}

@end
